package link.at17.mid.tushare.system.util;

import java.net.InetAddress;
import java.net.UnknownHostException;

import jakarta.servlet.http.HttpServletRequest;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public class IPTools {
    public static String getClientIP(HttpServletRequest request){
        String[] headers = {"x-real-ip", "client-ip", "x-forwarded-for", "x-forwarded", "x-cluster-client-ip", "forwarded-for", "forwarded"};
        
        /*request.getHeaderNames().asIterator().forEachRemaining(header -> {
            log.info("{header: {}, value: {}}", header, request.getHeader(header));
        });*/
        
        String ipAddress = null;
        for(String header : headers) {
            ipAddress = request.getHeader(header);
            if(!(ipAddress == null || ipAddress.length() == 0 || "unknown".equalsIgnoreCase(ipAddress))) {  
                break;
            }  
        }
        if(ipAddress == null || ipAddress.length() == 0 || "unknown".equalsIgnoreCase(ipAddress)) {  
            ipAddress = request.getRemoteAddr();  
            if(ipAddress.equals("127.0.0.1") || ipAddress.equals("0:0:0:0:0:0:0:1") || ipAddress.equals("::1")){  
                //根据网卡取本机配置的IP  
                InetAddress inet=null;  
                try {  
                    inet = InetAddress.getLocalHost();  
                } catch (UnknownHostException e) {  
                    e.printStackTrace();  
                }  
                ipAddress= inet.getHostAddress();  
            }  
        }  
        //对于通过多个代理的情况，第一个IP为客户端真实IP,多个IP按照','分割  
        if(ipAddress!=null && ipAddress.length()>15){ //"***.***.***.***".length() = 15  
            if(ipAddress.indexOf(",") > 0){  
                ipAddress = ipAddress.substring(0,ipAddress.indexOf(","));  
            }
        }  
        return ipAddress; 
    }
}
